$(document).ready(function(){
    document.body.addEventListener("click", function (event) {
        let dropdowns = document.querySelectorAll(".dropdown-container");
        for(let item of dropdowns){
            if (item.contains(event.target))
                return;
        }
        if (event.target.classList.contains("ui-icon-circle-triangle-e")
            || event.target.classList.contains("ui-icon-circle-triangle-w")
            || event.target.classList.contains("ui-datepicker-prev")
            || event.target.classList.contains("ui-datepicker-next"))
            return
        document.querySelectorAll('table.data-grid').forEach(item => {
            item.classList.remove('filter-is-opened')
        })
        dropdowns.forEach(item => {item.classList.remove("visible")})
    })
})

function initDropdown(ref, columnId, filterBtn, dropdownId, datepickerStartId, datepickerEndId, datepickerStart, datepickerEnd) { 
    initDatepicker(ref, datepickerStartId, datepickerEndId, datepickerStart, datepickerEnd)    
    let dropdown = document.getElementById(dropdownId);
    document.getElementById(filterBtn)?.addEventListener("click", function (event) {
        if (dropdown?.contains(event.target))
            return
        ref?.invokeMethodAsync('clearFilter')
        if (!dropdown?.classList.contains("visible")) {
            document.querySelectorAll('table.data-grid').forEach(item => {
                if(item.contains(dropdown)) {
                    item.classList.add('filter-is-opened')
                    item.querySelectorAll('th').forEach(th => {
                        th.classList.remove('current-column')
                    })
                    document.getElementById(columnId).classList.add('current-column')
                }
            })
        }
        else{
            document.querySelectorAll('table.data-grid').forEach(item => {
                item.classList.remove('filter-is-opened')
            })
        }
        event.preventDefault();
        event.stopPropagation();
        let dropdowns = document.querySelectorAll(".dropdown-container");
        dropdowns?.forEach(item => {
            if (item.id !== dropdownId)
                item.classList.remove("visible")
        })
        dropdown?.classList.toggle("visible")
    })
}

function hideDropdown(dropdownId) {
    document.querySelectorAll('table.data-grid').forEach(item => {
        item.classList.remove('filter-is-opened')
    })
    document.getElementById(dropdownId).classList.remove("visible")
}

function initDatepicker(ref, datepickerStartId, datepickerEndId, datepickerStart, datepickerEnd){
    let dateFormat = "dd/mm/yyyy",
        from = $("#" + datepickerStartId),
        to = $("#" + datepickerEndId)
    from.datepicker({
        defaultDate: datepickerStart != null ? new Date(datepickerStart) : null,
        changeMonth: true,
        numberOfMonths: 1,
        dateFormat: dateFormat,
        changeYear: true,
        firstDay: 1,
        maxDate: datepickerEnd != null ? new Date(datepickerEnd) : null
    })
        .on("change", function () {
            refreshDatepicker(datepickerStartId, datepickerEndId, from.datepicker("getDate"), to.datepicker("getDate"))
            ref?.invokeMethodAsync('setStartDate', getDate(this))
        })
    to.datepicker({
        defaultDate: datepickerEnd != null ? new Date(datepickerEnd) : null,
        changeMonth: true,
        numberOfMonths: 1,
        dateFormat: dateFormat,
        changeYear: true,
        firstDay: 1,
        minDate: datepickerStart != null ? new Date(datepickerStart) : null
    })
        .on("change", function () {
            refreshDatepicker(datepickerStartId, datepickerEndId, from.datepicker("getDate"), to.datepicker("getDate"))
            ref?.invokeMethodAsync('setEndDate', getDate(this))
        });

    function getDate(element) {
        let date;
        try {
            date = $.datepicker.parseDate(dateFormat, element.value);
        } catch (error) {
            date = null;
        }

        return date;
    }
}

function refreshDatepicker(datepickerStartId, datepickerEndId, datepickerStart, datepickerEnd) {
    let from = $("#" + datepickerStartId),
        to = $("#" + datepickerEndId)
    from.datepicker("option", "maxDate", datepickerEnd != null ? new Date(datepickerEnd) : null);
    to.datepicker("option", "minDate", datepickerStart != null ? new Date(datepickerStart) : null);
    from.datepicker('setDate', datepickerStart != null ? new Date(datepickerStart) : null);
    to.datepicker('setDate', datepickerEnd != null ? new Date(datepickerEnd) : null);
    if (datepickerStart == null)
        from.find(".ui-state-active").removeClass("ui-state-active");
    if (datepickerEnd == null)
        to.find(".ui-state-active").removeClass("ui-state-active");
}
